Index: /trunk/admin/user_perm.php
===================================================================
--- /trunk/admin/user_perm.php	(revision 21)
+++ /trunk/admin/user_perm.php	(revision 21)
@@ -0,0 +1,174 @@
+<?php
+/***************************************************************************
+ *                               user_perm.php                             *
+ *                            ------------------                           *
+ *   application          : PhpWebGallery 1.3                              *
+ *   author               : Pierrick LE GALL <pierrick@z0rglub.com>        *
+ *                                                                         *
+ ***************************************************************************/
+
+/***************************************************************************
+ *                                                                         *
+ *   This program is free software; you can redistribute it and/or modify  *
+ *   it under the terms of the GNU General Public License as published by  *
+ *   the Free Software Foundation;                                         *
+ *                                                                         *
+ ***************************************************************************/
+include_once( './include/isadmin.inc.php' );
+//----------------------------------------------------- template initialization
+$sub = $vtp->Open( '../template/'.$user['template'].'/admin/user_perm.vtp' );
+$error = array();
+$tpl = array( 'permuser_authorized','permuser_forbidden','submit',
+              'permuser_parent_forbidden','permuser_info_message',
+              'adduser_info_back' );
+templatize_array( $tpl, 'lang', $sub );
+//--------------------------------------------------------------------- updates
+if ( isset( $_POST['submit'] ) )
+{
+  // cleaning the user_access table for this user
+  $query = 'DELETE FROM '.PREFIX_TABLE.'user_access';
+  $query.= ' WHERE user_id = '.$_GET['user_id'];
+  $query.= ';';
+  mysql_query( $query );
+  // selecting all private categories
+  $query = 'SELECT id';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  $query.= " WHERE status = 'private'";
+  $query.= ';';
+  $result = mysql_query( $query );
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    $radioname = 'access-'.$row['id'];
+    if ( $_POST[$radioname] == 0 )
+    {
+      $query = 'INSERT INTO '.PREFIX_TABLE.'user_access';
+      $query.= ' (user_id,cat_id) VALUES';
+      $query.= ' ('.$_GET['user_id'].','.$row['id'].')';
+      $query.= ';';
+      mysql_query ( $query );
+    }
+  }
+  check_favorites( $_GET['user_id'] );
+  $vtp->addSession( $sub, 'confirmation' );
+  $url = './admin.php?page=user_list';
+  $vtp->setVar( $sub, 'confirmation.back_url', add_session_id( $url ) );
+  $vtp->closeSession( $sub, 'confirmation' );
+}
+//---------------------------------------------------------------- form display
+$restrictions = get_restrictions( $_GET['user_id'], $page['user_status'],
+                                  false, false );
+$action = './admin.php?page=user_perm&amp;user_id='.$_GET['user_id'];
+$vtp->setVar( $sub, 'action', add_session_id( $action ) );
+// Association of group_ids with group_names -> caching informations
+$query = 'SELECT id,name';
+$query.= ' FROM '.PREFIX_TABLE.'groups';
+$query.= ';';
+$result = mysql_query( $query );
+$groups = array();
+while ( $row = mysql_fetch_array( $result ) )
+{
+  $groups[$row['id']] = $row['name'];
+}
+// Listing of groups the user belongs to
+$query = 'SELECT ug.group_id as groupid';
+$query.= ' FROM '.PREFIX_TABLE.'user_group as ug';
+$query.= ' WHERE user_id = '.$_GET['user_id'];
+$query.= ';';
+$result = mysql_query( $query );
+$usergroups = array();
+while ( $row = mysql_fetch_array( $result ) )
+{
+  array_push( $usergroups, $row['groupid'] );
+}
+// only private categories are listed
+$query = 'SELECT id';
+$query.= ' FROM '.PREFIX_TABLE.'categories';
+$query.= " WHERE status = 'private'";
+$query.= ';';
+$result = mysql_query( $query );
+while ( $row = mysql_fetch_array( $result ) )
+{
+  $vtp->addSession( $sub, 'category' );
+  $vtp->setVar( $sub, 'category.id', $row['id'] );
+  // we have to know whether the user is authorized to access this
+  // category. The category can be accessible for this user thanks to his
+  // personnal access rights OR thanks to the access rights of a group he
+  // belongs to.
+  // 1. group access :
+  //    retrieving all authorized groups for this category and for this user
+  $query = 'SELECT ga.group_id as groupid';
+  $query.= ' FROM '.PREFIX_TABLE.'group_access as ga';
+  $query.= ', '.PREFIX_TABLE.'user_group as ug';
+  $query.= ' WHERE ga.group_id = ug.group_id';
+  $query.= ' AND ug.user_id = '.$_GET['user_id'];
+  $query.= ' AND cat_id = '.$row['id'];
+  $query.= ';';
+  $subresult = mysql_query( $query );
+  $authorized_groups = array();
+  while ( $subrow = mysql_fetch_array( $subresult ) )
+  {
+    array_push( $authorized_groups, $subrow['groupid'] );
+  }
+  // 2. personnal access
+  $is_user_allowed = is_user_allowed( $row['id'], $restrictions );
+  // link to the category permission management
+  $url = './admin.php?page=cat_perm&amp;cat_id='.$row['id'];
+  $vtp->setVar( $sub, 'category.cat_perm_link', add_session_id( $url ) );
+  // color of the category : green if the user is allowed by himself or
+  // thanks to a group he belongs to
+  if ( $is_user_allowed == 0 or count( $authorized_groups ) > 0 )
+  {
+    $vtp->setVar( $sub, 'category.color', 'green' );
+  }
+  else
+  {
+    $vtp->setVar( $sub, 'category.color', 'red' );
+  }
+  // category name
+  $cat_infos = get_cat_info( $row['id'] );
+  $name = get_cat_display_name( $cat_infos['name'],' &gt; ',
+                                'font-weight:bold;' );
+  $vtp->setVar( $sub, 'category.name', $name );
+  // usergroups
+  if ( count( $usergroups ) > 0 )
+  {
+    $vtp->addSession( $sub, 'usergroups' );
+    foreach ( $usergroups as $i => $usergroup ) {
+      $vtp->addSession( $sub, 'usergroup' );
+      $vtp->setVar( $sub, 'usergroup.name', $groups[$usergroup] );
+      if ( in_array( $usergroup, $authorized_groups ) )
+      {
+        $vtp->setVar( $sub, 'usergroup.color', 'green' );
+      }
+      else
+      {
+        $vtp->setVar( $sub, 'usergroup.color', 'red' );
+      }
+      if ( $i < count( $usergroups ) - 1 )
+      {
+        $vtp->setVar( $sub, 'usergroup.separation', ',' );
+      }
+      $vtp->closeSession( $sub, 'usergroup' );
+    }
+    $vtp->closeSession( $sub, 'usergroups' );
+  }
+  // any subcat forbidden for this user ?
+  if ( $is_user_allowed == 2 )
+  {
+    $vtp->addSession( $sub, 'parent_forbidden' );
+    $vtp->closeSession( $sub, 'parent_forbidden' );
+  }
+  // personnal forbidden or authorized access ?
+  if ( $is_user_allowed == 0 )
+  {
+    $vtp->setVar( $sub, 'category.authorized_checked', ' checked="checked"' );
+  }
+  else
+  {
+    $vtp->setVar( $sub, 'category.forbidden_checked', ' checked="checked"' );
+  }
+  $vtp->closeSession( $sub, 'category' );
+}
+//----------------------------------------------------------- sending html code
+$vtp->Parse( $handle , 'sub', $sub );
+?>
Index: /trunk/include/config.inc.php
===================================================================
--- /trunk/include/config.inc.php	(revision 20)
+++ /trunk/include/config.inc.php	(revision 21)
@@ -21,6 +21,6 @@
 $lang = array();
 
-include_once( PREFIXE_INCLUDE.'./include/functions.inc.php' );
-include_once( PREFIXE_INCLUDE.'./include/vtemplate.class.php' );
+include_once( PREFIX_INCLUDE.'./include/functions.inc.php' );
+include_once( PREFIX_INCLUDE.'./include/vtemplate.class.php' );
 
 // How to change the order of display for images in a category ?
Index: /trunk/include/functions.inc.php
===================================================================
--- /trunk/include/functions.inc.php	(revision 20)
+++ /trunk/include/functions.inc.php	(revision 21)
@@ -19,4 +19,5 @@
 include( 'functions_category.inc.php' );
 include( 'functions_xml.inc.php' );
+include( 'functions_group.inc.php' );
 
 //----------------------------------------------------------- generic functions
@@ -320,13 +321,15 @@
 function database_connection()
 {
-  // $cfgHote,$cfgUser,$cfgPassword,$cfgBase;
-
-  $xml_content = getXmlCode( PREFIXE_INCLUDE.'./include/database_config.xml' );
-  $mysql_conf = getChild( $xml_content, 'mysql' );
-
-  $cfgHote     = getAttribute( $mysql_conf, 'host' );
-  $cfgUser     = getAttribute( $mysql_conf, 'user' );
-  $cfgPassword = getAttribute( $mysql_conf, 'password' );
-  $cfgBase     = getAttribute( $mysql_conf, 'base' );
+//   $xml_content = getXmlCode( PREFIXE_INCLUDE.'./include/database_config.xml' );
+//   $mysql_conf = getChild( $xml_content, 'mysql' );
+
+//   $cfgHote     = getAttribute( $mysql_conf, 'host' );
+//   $cfgUser     = getAttribute( $mysql_conf, 'user' );
+//   $cfgPassword = getAttribute( $mysql_conf, 'password' );
+//   $cfgBase     = getAttribute( $mysql_conf, 'base' );
+//   define( PREFIX_TABLE, getAttribute( $mysql_conf, 'tablePrefix' ) );
+
+  include( PREFIX_INCLUDE.'./include/mysql.inc.php' );
+  define( PREFIX_TABLE, $prefix_table );
 
   @mysql_connect( $cfgHote, $cfgUser, $cfgPassword )
@@ -334,6 +337,4 @@
   @mysql_select_db( $cfgBase )
     or die ( "Could not connect to database" );
-
-  define( PREFIX_TABLE, getAttribute( $mysql_conf, 'tablePrefix' ) );
 }
 
Index: /trunk/include/functions_category.inc.php
===================================================================
--- /trunk/include/functions_category.inc.php	(revision 20)
+++ /trunk/include/functions_category.inc.php	(revision 21)
@@ -15,25 +15,23 @@
  *                                                                         *
  ***************************************************************************/
+
 function get_subcats_id( $cat_id )
 {
-  $restricted_cat = array();
-  $i = 0;
+  $restricted_cats = array();
                 
-  $query = 'select id';
-  $query.= ' from '.PREFIX_TABLE.'categories';
-  $query.= ' where id_uppercat = '.$cat_id;
+  $query = 'SELECT id';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  $query.= ' WHERE id_uppercat = '.$cat_id;
   $query.= ';';
   $result = mysql_query( $query );
   while ( $row = mysql_fetch_array( $result ) )
   {
-    $restricted_cat[$i++] = $row['id'];
-    $sub_restricted_cat = get_subcats_id( $row['id'] );
-    for ( $j = 0; $j < sizeof( $sub_restricted_cat ); $j++ )
-    {
-      $restricted_cat[$i++] = $sub_restricted_cat[$j];
-    }
-  }
-                
-  return $restricted_cat;
+    array_push( $restricted_cats, $row['id'] );
+    $sub_restricted_cats = get_subcats_id( $row['id'] );
+    foreach ( $sub_restricted_cats as $sub_restricted_cat ) {
+      array_push( $restricted_cats, $sub_restricted_cat );
+    }
+  }
+  return $restricted_cats;
 }
 
Index: /trunk/include/functions_group.inc.php
===================================================================
--- /trunk/include/functions_group.inc.php	(revision 21)
+++ /trunk/include/functions_group.inc.php	(revision 21)
@@ -0,0 +1,104 @@
+<?php
+/***************************************************************************
+ *                           functions_group.inc.php                       *
+ *                            --------------------                         *
+ *   application          : PhpWebGallery 1.3                              *
+ *   author               : Pierrick LE GALL <pierrick@z0rglub.com>        *
+ *                                                                         *
+ ***************************************************************************
+
+ ***************************************************************************
+ *                                                                         *
+ *   This program is free software; you can redistribute it and/or modify  *
+ *   it under the terms of the GNU General Public License as published by  *
+ *   the Free Software Foundation;                                         *
+ *                                                                         *
+ ***************************************************************************/
+
+// get_group_restrictions returns an array containing all unaccessible
+// category ids.
+function get_group_restrictions( $group_id )
+{
+  // 1. retrieving ids of private categories
+  $query = 'SELECT id';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  $query.= " WHERE status = 'private'";
+  $query.= ';';
+  $result = mysql_query( $query );
+  $privates = array();
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    array_push( $privates, $row['id'] );
+  }
+  // 2. retrieving all authorized categories for the group
+  $authorized = array();
+  $query = 'SELECT cat_id';
+  $query.= ' FROM '.PREFIX_TABLE.'group_access';
+  $query.= ' WHERE group_id = '.$group_id;
+  $query.= ';';
+  $result = mysql_query( $query );
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    array_push( $authorized, $row['cat_id'] );
+  }
+
+  $forbidden = array();
+  foreach ( $privates as $private ) {
+    if ( !in_array( $private, $authorized ) )
+    {
+      array_push( $forbidden, $private );
+    }
+  }
+
+  return $forbidden;
+}
+
+// get_all_group_restrictions returns an array with ALL unaccessible
+// category ids, including sub-categories
+function get_all_group_restrictions( $group_id )
+{
+  $restricted_cats = get_group_restrictions( $group_id );
+  foreach ( $restricted_cats as $restricted_cat ) {
+    $sub_restricted_cats = get_subcats_id( $restricted_cat );
+    foreach ( $sub_restricted_cats as $sub_restricted_cat ) {
+      array_push( $restricted_cats, $sub_restricted_cat );
+    }
+  }
+  return $restricted_cats;
+}
+
+// The function is_group_allowed returns :
+//      - 0 : if the category is allowed with this $restrictions array
+//      - 1 : if this category is not allowed
+//      - 2 : if an uppercat category is not allowed
+function is_group_allowed( $category_id, $restrictions )
+{
+  $lowest_category_id = $category_id;
+                
+  $is_root = false;
+  while ( !$is_root and !in_array( $category_id, $restrictions ) )
+  {
+    $query = 'SELECT id_uppercat';
+    $query.= ' FROM '.PREFIX_TABLE.'categories';
+    $query.= ' WHERE id = '.$category_id;
+    $query.= ';';
+    $row = mysql_fetch_array( mysql_query( $query ) );
+    if ( $row['id_uppercat'] == '' )
+    {
+      $is_root = true;
+    }
+    $category_id = $row['id_uppercat'];
+  }
+                
+  if ( in_array( $lowest_category_id, $restrictions ) )
+  {
+    return 1;
+  }
+  if ( in_array( $category_id, $restrictions ) )
+  {
+    return 2;
+  }
+  // this group is allowed to go in this category
+  return 0;
+}
+?>
Index: /trunk/include/functions_user.inc.php
===================================================================
--- /trunk/include/functions_user.inc.php	(revision 20)
+++ /trunk/include/functions_user.inc.php	(revision 21)
@@ -145,20 +145,20 @@
     mysql_query( $query );
     // 3. retrieving the id of the newly created user
-    $query = 'select id';
-    $query.= ' from '.PREFIX_TABLE.'users';
-    $query.= " where username = '".$login."';";
+    $query = 'SELECT id';
+    $query.= ' FROM '.PREFIX_TABLE.'users';
+    $query.= " WHERE username = '".$login."';";
     $row = mysql_fetch_array( mysql_query( $query ) );
     $user_id = $row['id'];
-    // 4. adding restrictions to the new user, the same as the user "guest"
-    $query = 'select cat_id';
-    $query.= ' from '.PREFIX_TABLE.'restrictions as r';
+    // 4. adding access to the new user, the same as the user "guest"
+    $query = 'SELECT cat_id';
+    $query.= ' FROM '.PREFIX_TABLE.'user_access as ua';
     $query.=      ','.PREFIX_TABLE.'users as u ';
-    $query.= ' where u.id = r.user_id';
+    $query.= ' where u.id = ua.user_id';
     $query.= " and u.username = 'guest';";
     $result = mysql_query( $query );
     while( $row = mysql_fetch_array( $result ) )
     {
-      $query = 'insert into '.PREFIX_TABLE.'restrictions';
-      $query.= ' (user_id,cat_id) values';
+      $query = 'INSERT INTO '.PREFIX_TABLE.'user_access';
+      $query.= ' (user_id,cat_id) VALUES';
       $query.= ' ('.$user_id.','.$row['cat_id'].');';
       mysql_query ( $query );
@@ -182,6 +182,6 @@
   if ( sizeof( $error ) == 0 )
   {
-    $query = 'update '.PREFIX_TABLE.'users';
-    $query.= " set status = '".$status."'";
+    $query = 'UPDATE '.PREFIX_TABLE.'users';
+    $query.= " SET status = '".$status."'";
     if ( $use_new_password )
     {
@@ -197,7 +197,6 @@
       $query.= 'NULL';
     }
-    $query.= ' where id = '.$user_id;
+    $query.= ' WHERE id = '.$user_id;
     $query.= ';';
-    echo $query;
     mysql_query( $query );
   }
@@ -210,5 +209,5 @@
 
   if ( $user['is_the_guest']
-       and ( $conf['acces'] == 'restreint' or $page['cat'] == 'fav' ) )
+       and ( $conf['access'] == 'restricted' or $page['cat'] == 'fav' ) )
   {
     echo '<div style="text-align:center;">'.$lang['only_members'].'<br />';
@@ -222,34 +221,73 @@
 // If the $check_invisible parameter is set to true, invisible categories
 // are added to the restricted one in the array.
-function get_restrictions( $user_id, $user_status, $check_invisible )
-{
-  // 1. getting the ids of the restricted categories
+function get_restrictions( $user_id, $user_status,
+                           $check_invisible, $use_groups = true )
+{
+  // 1. retrieving ids of private categories
+  $query = 'SELECT id';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  $query.= " WHERE status = 'private'";
+  $query.= ';';
+  $result = mysql_query( $query );
+  $privates = array();
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    array_push( $privates, $row['id'] );
+  }
+  // 2. retrieving all authorized categories for the user
+  $authorized = array();
+  // 2.1. retrieving authorized categories thanks to personnal user
+  //      authorization
   $query = 'SELECT cat_id';
-  $query.= ' FROM '.PREFIX_TABLE.'restrictions';
+  $query.= ' FROM '.PREFIX_TABLE.'user_access';
   $query.= ' WHERE user_id = '.$user_id;
   $query.= ';';
   $result = mysql_query( $query );
-
-  $restriction = array();
   while ( $row = mysql_fetch_array( $result ) )
   {
-    array_push( $restriction, $row['cat_id'] );
-  }
+    array_push( $authorized, $row['cat_id'] );
+  }
+  // 2.2. retrieving authorized categories thanks to group authorization to
+  //      which the user is a member
+  if ( $use_groups )
+  {
+    $query = 'SELECT ga.cat_id';
+    $query.= ' FROM '.PREFIX_TABLE.'user_group as ug';
+    $query.= ', '.PREFIX_TABLE.'group_access as ga';
+    $query.= ' WHERE ug.group_id = ga.group_id';
+    $query.= ' AND ug.user_id = '.$user_id;
+    $query.= ';';
+    $result = mysql_query( $query );
+    while ( $row = mysql_fetch_array( $result ) )
+    {
+      array_push( $authorized, $row['cat_id'] );
+    }
+    $authorized = array_unique( $authorized );
+  }
+
+  $forbidden = array();
+  foreach ( $privates as $private ) {
+    if ( !in_array( $private, $authorized ) )
+    {
+      array_push( $forbidden, $private );
+    }
+  }
+
   if ( $check_invisible )
   {
-    // 2. adding to the restricted categories, the invisible ones
+    // 3. adding to the restricted categories, the invisible ones
     if ( $user_status != 'admin' )
     {
       $query = 'SELECT id';
       $query.= ' FROM '.PREFIX_TABLE.'categories';
-      $query.= " WHERE status = 'invisible';";
+      $query.= " WHERE visible = 'false';";
       $result = mysql_query( $query );
       while ( $row = mysql_fetch_array( $result ) )
       {
-        array_push( $restriction, $row['id'] );
-      }
-    }
-  }
-  return $restriction;
+        array_push( $forbidden, $row['id'] );
+      }
+    }
+  }
+  return array_unique( $forbidden );
 }
 
@@ -259,15 +297,12 @@
 function get_all_restrictions( $user_id, $user_status )
 {
-  $restricted_cat = get_restrictions( $user_id, $user_status, true );
-  $i = sizeof( $restricted_cat );
-  for ( $k = 0; $k < sizeof( $restricted_cat ); $k++ )
-  {
-    $sub_restricted_cat = get_subcats_id( $restricted_cat[$k] );
-    for ( $j = 0; $j < sizeof( $sub_restricted_cat ); $j++ )
-    {
-      $restricted_cat[$i++] = $sub_restricted_cat[$j];
-    }
-  }
-  return $restricted_cat;
+  $restricted_cats = get_restrictions( $user_id, $user_status, true );
+  foreach ( $restricted_cats as $restricted_cat ) {
+    $sub_restricted_cats = get_subcats_id( $restricted_cat );
+    foreach ( $sub_restricted_cats as $sub_restricted_cat ) {
+      array_push( $restricted_cats, $sub_restricted_cat );
+    }
+  }
+  return $restricted_cats;
 }
 
@@ -278,6 +313,4 @@
 function is_user_allowed( $category_id, $restrictions )
 {
-  global $user;
-                
   $lowest_category_id = $category_id;
                 
@@ -285,10 +318,10 @@
   while ( !$is_root and !in_array( $category_id, $restrictions ) )
   {
-    $query = 'select id_uppercat';
-    $query.= ' from '.PREFIX_TABLE.'categories';
-    $query.= ' where id = '.$category_id;
+    $query = 'SELECT id_uppercat';
+    $query.= ' FROM '.PREFIX_TABLE.'categories';
+    $query.= ' WHERE id = '.$category_id;
     $query.= ';';
     $row = mysql_fetch_array( mysql_query( $query ) );
-    if ( $row['id_uppercat'] == "" )
+    if ( $row['id_uppercat'] == '' )
     {
       $is_root = true;
Index: /trunk/include/functions_xml.inc.php
===================================================================
--- /trunk/include/functions_xml.inc.php	(revision 20)
+++ /trunk/include/functions_xml.inc.php	(revision 21)
@@ -19,5 +19,4 @@
 define( ATT_REG, '\w+' );
 define( VAL_REG, '[^"]*' );
-
 //------------------------------------------------------------------- functions
 // getContent returns the content of a tag
@@ -33,5 +32,5 @@
   $content = preg_replace( '/^<[^>]+>/', '', $element );
   // deleting end of the tag
-  $content = preg_replace( '/<\/\w+>$/', '', $content );
+  $content = preg_replace( '/<\/[^>]+>$/', '', $content );
   // replacing multiple instance of space character
   $content = preg_replace( '/\s+/', ' ', $content );
@@ -40,6 +39,6 @@
 }
 
-// The function get Attribute returns the value corresponding to the attribute
-// $attribute for the tag $element.
+// The function get Attribute returns the value corresponding to the
+// attribute $attribute for the tag $element.
 function getAttribute( $element, $attribute )
 {
Index: /trunk/include/init.inc.php
===================================================================
--- /trunk/include/init.inc.php	(revision 20)
+++ /trunk/include/init.inc.php	(revision 21)
@@ -15,6 +15,6 @@
  *                                                                         *
  ***************************************************************************/
-define( PREFIXE_INCLUDE, '' );
-        
+define( PREFIX_INCLUDE, '' );
+
 include_once( './include/config.inc.php' );
 include_once( './include/user.inc.php' );
Index: /trunk/include/user.inc.php
===================================================================
--- /trunk/include/user.inc.php	(revision 20)
+++ /trunk/include/user.inc.php	(revision 21)
@@ -25,5 +25,5 @@
                 'long_period', 'template' );
 
-$query_user  = 'select';
+$query_user  = 'SELECT';
 for ( $i = 0; $i < sizeof( $infos ); $i++ )
 {
@@ -38,5 +38,5 @@
   $query_user.= $infos[$i];
 }
-$query_user.= ' from '.PREFIX_TABLE.'users';
+$query_user.= ' FROM '.PREFIX_TABLE.'users';
 $query_done = false;
 $user['is_the_guest'] = false;
@@ -45,7 +45,7 @@
 {
   $page['session_id'] = $_GET['id'];
-  $query = 'select user_id,expiration,ip';
-  $query.= ' from '.PREFIX_TABLE.'sessions';
-  $query.= " where id = '".$_GET['id']."'";
+  $query = 'SELECT user_id,expiration,ip';
+  $query.= ' FROM '.PREFIX_TABLE.'sessions';
+  $query.= " WHERE id = '".$_GET['id']."'";
   $query.= ';';
   $result = mysql_query( $query );
@@ -57,6 +57,6 @@
       // deletion of the session from the database,
       // because it is out-of-date
-      $delete_query = 'delete from '.PREFIX_TABLE.'sessions';
-      $delete_query.= " where id = '".$page['session_id']."'";
+      $delete_query = 'DELETE FROM '.PREFIX_TABLE.'sessions';
+      $delete_query.= " WHERE id = '".$page['session_id']."'";
       $delete_query.= ';';
       mysql_query( $delete_query );
@@ -66,5 +66,5 @@
       if ( $_SERVER['REMOTE_ADDR'] == $row['ip'] )
       {
-        $query_user .= ' where id = '.$row['user_id'];
+        $query_user .= ' WHERE id = '.$row['user_id'];
         $query_done = true;
       }
@@ -74,5 +74,5 @@
 if ( !$query_done )
 {
-  $query_user .= ' where id = 2';
+  $query_user .= ' WHERE id = 2';
   $user['is_the_guest'] = true;
 }
@@ -83,12 +83,11 @@
 // affectation of each value retrieved in the users table into a variable
 // of the array $user.
-for ( $i = 0; $i < sizeof( $infos ); $i++ )
-{
-  $user[$infos[$i]] = $row[$infos[$i]];
+foreach ( $infos as $info ) {
+  $user[$info] = $row[$info];
   // If the field is true or false, the variable is transformed into a
   // boolean value.
-  if ( $row[$infos[$i]] == 'true' || $row[$infos[$i]] == 'false' )
+  if ( $row[$info] == 'true' or $row[$info] == 'false' )
   {
-    $user[$infos[$i]] = get_boolean( $row[$infos[$i]] );
+    $user[$info] = get_boolean( $row[$info] );
   }
 }
